package org.processmining.plugins.complianceframework;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.complianceframework.model.ComplianceDashboard;

@Plugin(name = "Export Compliance Dashboard as file", returnLabels = {}, returnTypes = {}, parameterLabels = { "ComplianceDashboard",
		"File" }, userAccessible = true)
@UIExportPlugin(description = "Export Compliance Dashboard file", extension = "cdsb")
public class DashboardExportPlugin {
	@PluginVariant(requiredParameterLabels = { 0, 1 })
	public void export(UIPluginContext context, ComplianceDashboard dashboard, File file) throws IOException {
		file.createNewFile();
		FileOutputStream fileStream = new FileOutputStream(file);
		ObjectOutputStream out = new ObjectOutputStream(fileStream);
		out.writeObject(dashboard);
		out.close();
	}
}
