package org.processmining.plugins.complianceframework;

import java.io.InputStream;
import java.io.ObjectInputStream;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.plugins.complianceframework.model.ComplianceDashboard;

@Plugin(name = "Import Compliance Dashboard", parameterLabels = { "Filename" }, returnLabels = { "Compliance Dashboard" }, returnTypes = { ComplianceDashboard.class })
@UIImportPlugin(description = "Compliance Dashboard", extensions = { "cdsb" })
public class DashboardImportPlugin extends AbstractImportPlugin {

	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		ComplianceDashboard dashboard = null;
		ObjectInputStream in = new ObjectInputStream(input);
		dashboard = (ComplianceDashboard) in.readObject();
        in.close();
        input.close();
        return dashboard;
	}

}
