package org.processmining.plugins.complianceframework;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.DataElement;
import org.processmining.models.guards.Expression;

public class ExpressionHelper {

	public static boolean extractGuardNumbers(Expression expression, DataElement variable, List<Float> extractedNumbers) {
		//		if (!containsVariable(expression, variable))
		//			return true;
		//		if (expression.isComparisonExpression()) {
		//			if (getVariablesCount(expression) > 1)
		//				return false;
		//			if (expression.getOperand1() instanceof Expression) {
		//				if (expression.getOperand2() instanceof Expression) {
		//					return extractGuardNumbers((Expression) expression.getOperand1(), variable, extractedNumbers)
		//							& extractGuardNumbers((Expression) expression.getOperand2(), variable, extractedNumbers);
		//				} else if (expression.getOperand2() instanceof Number) {
		//					boolean operand1 = extractGuardNumbers((Expression) expression.getOperand1(), variable,
		//							extractedNumbers);
		//					if (operand1)
		//						extractedNumbers.add(((Number) expression.getOperand2()).floatValue());
		//					return operand1;
		//				} else if (expression.getOperand2() instanceof String
		//						&& ((String) expression.getOperand2()).replace("'", "").equals(variable.getVarName())) {
		//					return extractGuardNumbers((Expression) expression.getOperand1(), variable, extractedNumbers);
		//				} else
		//					return false;
		//			} else if (expression.getOperand1() instanceof String
		//					&& ((String) expression.getOperand1()).replace("'", "").equals(variable.getVarName())) {
		//				if (expression.getOperand1() instanceof Expression) {
		//					return extractGuardNumbers((Expression) expression.getOperand2(), variable, extractedNumbers);
		//				} else if (expression.getOperand2() instanceof Number) {
		//					extractedNumbers.add(((Number) expression.getOperand2()).floatValue());
		//					return true;
		//				} else
		//					return false;
		//			} else if (expression.getOperand1() instanceof Number) {
		//				if (expression.getOperand2() instanceof Expression) {
		//					boolean operand2 = extractGuardNumbers((Expression) expression.getOperand2(), variable,
		//							extractedNumbers);
		//					if (operand2)
		//						extractedNumbers.add(((Number) expression.getOperand1()).floatValue());
		//					return operand2;
		//				} else if (expression.getOperand2() instanceof String
		//						&& ((String) expression.getOperand2()).replace("'", "").equals(variable.getVarName())) {
		//					extractedNumbers.add(((Number) expression.getOperand1()).floatValue());
		//					return true;
		//				} else
		//					return false;
		//			} else
		//				return false;
		//		} else if (expression.isBooleanExpression()) {
		//			boolean operand1 = true, operand2 = true;
		//			if (expression.getOperand1() instanceof Expression
		//					&& containsVariable((Expression) expression.getOperand1(), variable)) {
		//				operand1 = extractGuardNumbers((Expression) expression.getOperand1(), variable, extractedNumbers);
		//			}
		//			if (expression.getOperand2() instanceof Expression
		//					&& containsVariable((Expression) expression.getOperand2(), variable)) {
		//				operand2 = extractGuardNumbers((Expression) expression.getOperand2(), variable, extractedNumbers);
		//			}
		//			return operand1 & operand2;
		//		} else if (expression.isMathematicalExpression()) {
		//			if (expression.findVariables().hasMoreElements())
		//				return true;
		//			Float expResult = calcMathExpression(expression);
		//			if (expResult != null) {
		//				extractedNumbers.add(expResult.floatValue());
		//				return true;
		//			} else
		//				return false;
		//		} else if (expression.getOperand1() instanceof Expression && expression.getOperator() == null) {
		//			return extractGuardNumbers((Expression) expression.getOperand1(), variable, extractedNumbers);
		//		} else
		//			return true;
		List<Object> extractedValues = new ArrayList<Object>();
		boolean result = extractGuardValues(expression, variable.getVarName(), extractedValues, Number.class);
		if (result) {
			for (Object value : extractedValues) {
				extractedNumbers.add(((Number) value).floatValue());
			}
		}
		return result;
	}

	public static boolean extractGuardValues(Expression expression, String variable, List<Object> extractedValues,
			Class<?> requiredClass) {
		if (!containsVariable(expression, variable))
			return true;
		if (expression.isComparisonExpression()) {
			if (getVariablesCount(expression) > 1)
				return false;
			if (expression.getOperand1() instanceof Expression) {
				if (expression.getOperand2() instanceof Expression) {
					return extractGuardValues((Expression) expression.getOperand1(), variable, extractedValues,
							requiredClass)
							& extractGuardValues((Expression) expression.getOperand2(), variable, extractedValues,
									requiredClass);
				} else if (expression.getOperand2() instanceof String
						&& ((String) expression.getOperand2()).replace("'", "").equals(variable)) {
					return extractGuardValues((Expression) expression.getOperand1(), variable, extractedValues,
							requiredClass);
				} else if (requiredClass.isInstance(expression.getOperand2())) {
					boolean operand1 = extractGuardValues((Expression) expression.getOperand1(), variable,
							extractedValues, requiredClass);
					if (operand1)
						extractedValues.add(expression.getOperand2());
					return operand1;
				} else
					return false;
			} else if (expression.getOperand1() instanceof String
					&& ((String) expression.getOperand1()).replace("'", "").equals(variable)) {
				if (expression.getOperand2() instanceof Expression) {
					return extractGuardValues((Expression) expression.getOperand2(), variable, extractedValues,
							requiredClass);
				} else if (requiredClass.isInstance(expression.getOperand2())) {
					extractedValues.add(expression.getOperand2());
					return true;
				} else
					return false;
			} else if (requiredClass.isInstance(expression.getOperand1())) {
				if (expression.getOperand2() instanceof Expression) {
					boolean operand2 = extractGuardValues((Expression) expression.getOperand2(), variable,
							extractedValues, requiredClass);
					if (operand2)
						extractedValues.add(expression.getOperand1());
					return operand2;
				} else if (expression.getOperand2() instanceof String
						&& ((String) expression.getOperand2()).replace("'", "").equals(variable)) {
					extractedValues.add(expression.getOperand1());
					return true;
				} else
					return false;
			} else
				return false;
		} else if (expression.isBooleanExpression()) {
			boolean operand1 = true, operand2 = true;
			if (expression.getOperand1() instanceof Expression
					&& containsVariable((Expression) expression.getOperand1(), variable)) {
				operand1 = extractGuardValues((Expression) expression.getOperand1(), variable, extractedValues,
						requiredClass);
			}
			if (expression.getOperand2() instanceof Expression
					&& containsVariable((Expression) expression.getOperand2(), variable)) {
				operand2 = extractGuardValues((Expression) expression.getOperand2(), variable, extractedValues,
						requiredClass);
			}
			return operand1 & operand2;
		} else if (expression.isMathematicalExpression()) {
			if (expression.findVariables().hasMoreElements())
				return true;
			Float expResult = calcMathExpression(expression);
			if (expResult != null) {
				extractedValues.add(expResult.floatValue());
				return true;
			} else
				return false;
		} else if (expression.getOperand1() instanceof Expression && expression.getOperator() == null) {
			return extractGuardValues((Expression) expression.getOperand1(), variable, extractedValues, requiredClass);
		} else
			return true;

	}

	public static int getVariablesCount(Expression expression) {
		int i = 0;
		Enumeration<String> vars = expression.findVariables();
		while (vars.hasMoreElements()) {
			i++;
			vars.nextElement();
		}
		return i;
	}

	public static boolean containsVariable(Expression expression, String variable) {
		boolean containsVariable = false;
		@SuppressWarnings("unchecked")
		Enumeration<String> vars = expression.findVariables();
		while (vars.hasMoreElements()) {
			if (vars.nextElement().toString().replace("'", "").equalsIgnoreCase(variable)) {
				containsVariable = true;
				break;
			}
		}
		if (containsVariable)
			return true;
		return false;
	}

	public static Float calcMathExpression(Expression expression) {
		Float result = 0.0f;
		try {
			if ((expression.getOperand1() == null && expression.getOperand2() == null)
					|| (expression.getOperator() != null && (expression.getOperand1() == null || expression
							.getOperand2() == null)))
				return null;
			if (expression.getOperator() == null) {
				if ((expression.getOperand1() != null && expression.getOperand2() != null))
					return null;
				else if (expression.getOperand1() != null && expression.getOperand1() instanceof Number) {
					return (((Number) expression.getOperand1()).floatValue());
				} else if (expression.getOperand2() != null && expression.getOperand2() instanceof Number) {
					return (((Number) expression.getOperand2()).floatValue());
				} else
					return null;
			}

			Float operand1, operand2;
			if (expression.getOperand1() instanceof Expression) {
				operand1 = calcMathExpression(expression);
			} else if (expression.getOperand1() instanceof Number)
				operand1 = ((Number) expression.getOperand1()).floatValue();
			else
				return null;

			if (expression.getOperand2() instanceof Expression) {
				operand2 = calcMathExpression(expression);
			} else if (expression.getOperand2() instanceof Number)
				operand2 = ((Number) expression.getOperand2()).floatValue();
			else
				return null;

			if (operand1 == null || operand2 == null)
				return null;

			if (expression.getOperator().equals("+"))
				result = operand1.floatValue() + operand2.floatValue();
			else if (expression.getOperator().equals("-"))
				result = operand1.floatValue() - operand2.floatValue();
			else if (expression.getOperator().equals("*"))
				result = operand1.floatValue() * operand2.floatValue();
			else if (expression.getOperator().equals("/"))
				result = operand1.floatValue() / operand2.floatValue();
			else if (expression.getOperator().equals("%"))
				result = operand1.floatValue() % operand2.floatValue();

			return result;
		} catch (Exception ex) {
			ex.printStackTrace();
			return null;
		}
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static Object getCompliantValue(Expression expression, String variable, Class<?> variableClass) {
		Object result = null;		
		Set<String> variables = expression.getVariableSet();
		if (variables.size() == 1) {
			List<Object> extractedObjectValues = new ArrayList<Object>();
			extractGuardValues(expression, variable.replace("'", ""), extractedObjectValues, variableClass);
			if (variableClass == String.class) {
				List<String> extractedValues = new ArrayList<String>();
				for (Object objectValue: extractedObjectValues) {
					String stringValue = (String) objectValue;
					extractedValues.add(stringValue.substring(1, stringValue.length()-1));
				}
				Hashtable varVals = new Hashtable();
				for (String value: extractedValues) {
					varVals.clear();
					varVals.put(variable, value);
					if (expression.isTrue(varVals)) {
						result = value;
						break;
					}
				}
				if (result == null) {
					result = "";
				}
			} else if (variableClass == Number.class) {
				List<Number> extractedValues = new ArrayList<Number>();
				for (Object objectValue: extractedObjectValues) {
					extractedValues.add((Number) objectValue);
				}
				Hashtable varVals = new Hashtable();
				for (Number value: extractedValues) {
					varVals.clear();
					varVals.put(variable, value);
					if (expression.isTrue(varVals)) {
						result = value;
						break;
					}
					varVals.clear();
					varVals.put(variable, value.floatValue() + 1);
					if (expression.isTrue(varVals)) {
						result = value.floatValue() + 1;
						break;
					}
					varVals.clear();
					varVals.put(variable, value.floatValue() - 1);
					if (expression.isTrue(varVals)) {
						result = value.floatValue() - 1;
						break;
					}
				}
			} else if (variableClass == Integer.class) {
				List<Integer> extractedValues = new ArrayList<Integer>();
				for (Object objectValue: extractedObjectValues) {
					extractedValues.add((Integer) objectValue);
				}
				Hashtable varVals = new Hashtable();
				for (Integer value: extractedValues) {
					varVals.clear();
					varVals.put(variable, value);
					if (expression.isTrue(varVals)) {
						result = value;
						break;
					}
					varVals.clear();
					varVals.put(variable, value.floatValue() + 1);
					if (expression.isTrue(varVals)) {
						result = value.floatValue() + 1;
						break;
					}
					varVals.clear();
					varVals.put(variable, value.floatValue() - 1);
					if (expression.isTrue(varVals)) {
						result = value.floatValue() - 1;
						break;
					}
				}
			} else if (variableClass == Float.class) {
				List<Float> extractedValues = new ArrayList<Float>();
				for (Object objectValue: extractedObjectValues) {
					extractedValues.add((Float) objectValue);
				}
				Hashtable varVals = new Hashtable();
				for (Float value: extractedValues) {
					varVals.clear();
					varVals.put(variable, value);
					if (expression.isTrue(varVals)) {
						result = value;
						break;
					}
					varVals.clear();
					varVals.put(variable, value.floatValue() + 1);
					if (expression.isTrue(varVals)) {
						result = value.floatValue() + 1;
						break;
					}
					varVals.clear();
					varVals.put(variable, value.floatValue() - 1);
					if (expression.isTrue(varVals)) {
						result = value.floatValue() - 1;
						break;
					}
				}
			}
		}
		return result;
	}
}
