package org.processmining.plugins.complianceframework.model;

import java.util.ArrayList;
import java.util.Collection;

import org.processmining.plugins.DataConformance.framework.ExecutionStep;
import org.processmining.plugins.DataConformance.framework.ExecutionTrace;

public class DashboardExecutionTrace extends ArrayList<DashboardExecutionStep> {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	protected String traceName;
	
	public DashboardExecutionTrace(int length, String traceName) {
		super(length);
		this.traceName=traceName;
	}
	
	public boolean isComplete(){
		return true;
	}
	
	public Collection<ExecutionTrace> successors(ExecutionStep activity) {
		return null;
	}
	
	protected byte numberOfBottomSteps=0;
	
	public DashboardExecutionTrace(int initialCapacity) {
		super(initialCapacity);
	}
	
	public boolean add(DashboardExecutionStep s) {
		if (s.getActivity() == null)
			numberOfBottomSteps++;
		return super.add(s);	
	}
	
	public boolean addAll(Collection<? extends DashboardExecutionStep> steps, byte numberOfBottomSteps) {
		this.numberOfBottomSteps=numberOfBottomSteps;
		return super.addAll(steps);
	}
	
	public boolean addAll(Collection<? extends DashboardExecutionStep> steps) {
		boolean changed=false;
		for(DashboardExecutionStep step : steps) {
			if (add(step))
				changed=true;
		}
		return changed;
	}
	
	public String toString()
	{
		StringBuffer buffer=new StringBuffer("[");
		for(DashboardExecutionStep step : this)
		{
			buffer.append(step.toString());
			buffer.append(",");
		}
		if (buffer.length()>1)
			buffer.deleteCharAt(buffer.length()-1);
		buffer.append(']');
		return buffer.toString();
	}
	
	public byte getNumberBottomSteps()
	{
		return numberOfBottomSteps;
	}
	
	public int lengthExecutionTraceWithoutBottomSteps() 
	{
		return this.size()-numberOfBottomSteps;
	}
	
	public DashboardExecutionStep getLast() {
		return this.get(this.size()-1);
	}
	
	public String getTraceName() {
		return traceName;
	}
}
