package org.processmining.plugins.datacompliance.GUI;

import java.awt.event.MouseEvent;
import java.util.List;

import org.processmining.plugins.petrinet.replayresult.StepTypes;
import org.processmining.plugins.petrinet.replayresult.visualization.ProcessInstanceConformanceView;

public class ProcessInstanceDataComplianceActivitiesView extends ProcessInstanceConformanceView {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6242796771166413645L;

	protected PNLogDataComplianceReplayResultVisPanel visPanel;

	public ProcessInstanceDataComplianceActivitiesView(String traceLabel, List<Object> nodeInstance, List<StepTypes> stepTypes,
			PNLogDataComplianceReplayResultVisPanel visPanel, int elementWidth) {
		super(traceLabel, nodeInstance, stepTypes, elementWidth);
		this.visPanel = visPanel;
	}

	@Override
	public void mouseDragged(MouseEvent evt) {
		super.mouseDragged(evt);
		this.mouseHandler(evt);
	}

	@Override
	public void mouseMoved(MouseEvent evt) {
		super.mouseMoved(evt);
		this.mouseHandler(evt);
	}

	protected void mouseHandler(MouseEvent evt) {
		int activeEvent = -1, activeNodeIndex = -1;
		if (mouseOver == true) {
			activeNodeIndex = mapEventIndex(mouseX, mouseY);
		} else
			return;
		activeEvent = activeNodeIndex;
		for (int i = 0; i <= activeNodeIndex; i++)
			if (this.stepTypes.get(i) == StepTypes.MINVI || this.stepTypes.get(i) == StepTypes.MREAL)
				activeEvent--;
		if (activeEvent < 0)
			return;
		this.visPanel.updateEventInfoModel(this, activeEvent);
	}
}
