package org.processmining.plugins.logmanipulator.GUI;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedHashMap;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.widgets.ProMList;
import org.processmining.plugins.logmanipulator.model.AttributeModifier;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class ManipulatorActionsPanel extends JPanel {
	protected UIPluginContext context;
	protected XLog log;

	protected ProMList<String> modifierList;
	protected DefaultListModel modifierListModel;
	protected int modifierIDCounter;

	protected JButton btn_AddAttrModifier;
	protected JButton btn_EditModifier;
	protected JButton btn_RemoveModifier;
	
	protected LinkedHashMap<String, AttributeModifier> modifiersMap;

	protected ActionListener addAttrModifierListener = new ActionListener() {

		public void actionPerformed(ActionEvent e) {
			Frame owner = JOptionPane.getFrameForComponent(ManipulatorActionsPanel.this);
			AttributeModifierConfigurationPanel attrModifier = new AttributeModifierConfigurationPanel(owner,
					ManipulatorActionsPanel.this.log);
			attrModifier.setLocationRelativeTo(owner);
			attrModifier.setVisible(true);
			if (attrModifier.getNewModifier()!= null) {
				ManipulatorActionsPanel.this.addModifier(attrModifier.getNewModifier());
			}
		}
	};

	boolean flag = true;

	public ManipulatorActionsPanel(UIPluginContext context, XLog log) {
		this.context = context;
		this.log = log;
		this.modifiersMap = new LinkedHashMap<String, AttributeModifier>();
		this.modifierListModel = new DefaultListModel();
		this.modifierIDCounter = 0;
		this.init();
	}

	public void init() {
		//		GridLayout layout = new GridLayout(1, 2);
		BorderLayout layout = new BorderLayout(2, 2);
		this.setLayout(layout);

		//configure filter list
		this.modifierList = new ProMList<String>("Modifier List", this.modifierListModel);
		Dimension filterListSize = new Dimension(5, this.getHeight() - 10);
		this.modifierList.setPreferredSize(filterListSize);
		this.add(this.modifierList, BorderLayout.CENTER);
		this.add(this.createModifierControlPanel(), BorderLayout.EAST);

	}

	@Override
	public void paint(java.awt.Graphics g) {
		super.paint(g);

		//		if (flag) {
		//			Dimension filterListSize = new Dimension(10, this.getHeight()-10);
		//			this.filterList.setPreferredSize(filterListSize);
		//			this.filterList.setMaximumSize(filterListSize);
		//			flag = false;
		//		}
	}

	protected JPanel createModifierControlPanel() {
		JPanel result = SlickerFactory.instance().createGradientPanel();
		BoxLayout layout = new BoxLayout(result, BoxLayout.Y_AXIS);
		result.setLayout(layout);

		this.btn_AddAttrModifier = SlickerFactory.instance().createButton("Add attribute modifier");
		this.btn_AddAttrModifier.setAlignmentX(Component.CENTER_ALIGNMENT);
		this.btn_AddAttrModifier.addActionListener(addAttrModifierListener);

		this.btn_EditModifier = SlickerFactory.instance().createButton("Edit modifier");
		this.btn_EditModifier.setAlignmentX(Component.CENTER_ALIGNMENT);
		this.btn_EditModifier.setEnabled(false);

		this.btn_RemoveModifier = SlickerFactory.instance().createButton("Remove modifier");
		this.btn_RemoveModifier.setAlignmentX(Component.CENTER_ALIGNMENT);
		this.btn_RemoveModifier.setEnabled(false);

		result.add(Box.createVerticalStrut(10));
		result.add(this.btn_AddAttrModifier);
		result.add(Box.createVerticalStrut(10));
		result.add(this.btn_EditModifier);
		result.add(Box.createVerticalStrut(10));
		result.add(this.btn_RemoveModifier);

		return result;
	}

	protected void addModifier(AttributeModifier modifier) {
		String modifierID = modifier.toString() + " modifier " + this.modifierIDCounter;
		this.modifierIDCounter++;
		this.modifiersMap.put(modifierID, modifier);
		this.modifierListModel.addElement(modifierID);
	}
	
	public LinkedHashMap<String, AttributeModifier> getModfiersMap(){
		return this.modifiersMap;
	}
}
