package org.processmining.plugins.logmanipulator.model;

import java.util.ArrayList;
import java.util.List;

import org.deckfour.xes.model.XEvent;

public class CaseIDFilter extends AbstractFilter {

	protected boolean isLiteral;
	protected List<int[]> intervals;
	//though it is called patterns, the exact match is required (for now) 
	protected List<String> patterns;

	public CaseIDFilter(boolean isLiteral, List<Object> restrictions) {
		this.isLiteral = isLiteral;
		if (isLiteral) {
			patterns = new ArrayList<String>();
			for (Object o : restrictions)
				patterns.add(o.toString());
		} else {
			intervals = new ArrayList<int[]>();
			for (Object o : restrictions)
				intervals.add((int[]) o);
		}
	}

	public boolean keep(XEvent event, String caseID) {
		if (this.isLiteral) {
			if (this.patterns.contains(caseID))
				return true;
			return false;
		} else {
			int caseIDInt = Integer.parseInt(caseID);
			for (int[] interval : intervals)
				if (caseIDInt >= interval[0] && caseIDInt <= interval[1])
					return true;
			return false;
		}
	}

	@Override
	public String toString() {
		return "Case ID";
	}

	public List<int[]> getIntervals() {
		return this.intervals;
	}

	public List<String> getPatterns() {
		return this.patterns;
	}

	public boolean isLiteral() {
		return this.isLiteral;
	}
}
